use std::collections::HashMap;

#[derive(Debug, serde::Serialize, serde::Deserialize)]
pub struct Versions {
    #[serde(skip_serializing_if = "Option::is_none")]
    unstable_features: Option<HashMap<String, String>>,
    versions: Vec<String>,
}

impl Default for Versions {
    fn default() -> Self {
        Self {
            unstable_features: None,
            versions: vec!["v1.2".into()],
        }
    }
}
